unit Igra;

interface

uses
  Dialogs, Objects, Views, Drivers, Tezina, MsgBox;

const
  cmBrojStart = 1101;
  cmBrojEnd = 1200;
  cmPobeda = 1210;
  cmIzgubljena = 1220;

type
  PIgraDlg = ^TIgraDlg;
  TIgraDlg = object(TDialog)
    Broj: Byte;
    Pokusaj: Byte;
    constructor Init(T: Word; B: Byte);
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

implementation

constructor TIgraDlg.Init(T: Word; B: Byte);
var
  R: TRect;
  X, Y, mX, mY: Byte;
  cmBroj: Word;
  S: String;
begin
  Pokusaj := 0;
  case T of
    cmLako:
    begin
      mX := 4;
      mY := 1;
    end;
    cmSrednje:
    begin
      mX := 4;
      mY := 3;
    end;
    cmTesko:
    begin
      mX := 9;
      mY := 4;
    end;
  end;
  R.Assign(0, 0, 10 + mX * 7, 7 + mY * 4);
  inherited Init(R, 'Pogodi broj');
  Broj := B;
  Options := Options or ofCentered;
  for Y := 0 to mY do
    for X := 0 to mX do
    begin
      cmBroj := (X + 1) + (Y * (mX + 1));
      Str(cmBroj, S);
      R.Assign(1 + X * 7, 2 + Y * 4, 8 + X * 7, 6 + Y * 4);
      Insert(New(PButton, Init(R, S, cmBroj + cmBrojStart - 1, bfNormal)));
    end;
  SelectNext(False);
end;

procedure TIgraDlg.HandleEvent(var Event: TEvent);
var
  B: Word;
begin
  inherited HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmBrojStart..cmBrojEnd:
      begin
        B := Event.Command - cmBrojStart + 1;
        ClearEvent(Event);
        if B = Broj then
          EndModal(cmPobeda)
        else
        begin
          Inc(Pokusaj);
          if Pokusaj = 3 then
            EndModal(cmIzgubljena)
          else if B < Broj then
            MessageBox('Trazeni broj je veci', nil, mfInformation or mfOKButton)
          else
            MessageBox('Trazeni broj je manji', nil, mfInformation or mfOKButton)
        end;

      end;
    end;
  end;
end;

end.